/* -*-c-*-
 *
 * $Id: ident.h,v 1.2 1999/07/26 23:26:44 mdw Exp $
 *
 * Parse replies from RFC931 servers
 *
 * (c) 1999 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of the `fw' port forwarder.
 *
 * `fw' is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * `fw' is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with `fw'; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*----- Revision history --------------------------------------------------* 
 *
 * $Log: ident.h,v $
 * Revision 1.2  1999/07/26 23:26:44  mdw
 * Change copyright notice.
 *
 * Revision 1.1.1.1  1999/07/01 08:56:23  mdw
 * Initial revision.
 *
 * Revision 1.1.1.1  1999/05/21 22:22:27  mdw
 * Initial import.  Code not really finished yet.
 *
 */

#ifndef IDENT_H
#define IDENT_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Data structures ---------------------------------------------------*/

typedef struct ident {
  unsigned short sport, dport;		/* Source and destination ports */
  unsigned type;			/* Type of reply from server */
  union {
    struct {
      char *os;				/* Operating system name */
      char *user;			/* User name */
    } userid;
    char *error;			/* Error message from server */
  } u;
} ident;

enum {
  ident_userid,
  ident_error,
  ident_bad
};

/*----- Functions provided ------------------------------------------------*/

/* --- @ident_parse@ --- *
 *
 * Arguments:	@char *p@ = pointer to input string from identd
 *		@ident *i@ = pointer to output block
 *
 * Returns:	---
 *
 * Use:		Parses a result string from an RFC931 (identd) server.
 */

extern void ident_parse(char */*p*/, ident */*i*/);

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
